<?php
// SOURCE : http://www.julien-breux.com/2009/08/22/tutoriel-prestashop-creer-un-module-avec-onglet/
if (!defined('_CAN_LOAD_FILES_'))
	exit;
class AddThis extends Module{
	
	private $tbl_styles = array(
		0 => "No style",
		1 => "Style 1",
		2 => "Style 2",
		3 => "Style 3",
		4 => "Style 4",
		5 => "Style 5",
		6 => "Style 6",
		7 => "Style 7",
		8 => "Follow Us",
		9 => "facebook (like) et twitter (tweet)"
	);
	
	public function __construct(){
		$this->name = 'addthis';
		$this->tab = 'add_this';
		$this->version = '1.0';
		$this->author = 'MICHAEL D.';
		parent::__construct();
		$this->displayName = $this->l('AddThis Experience');
		$this->description = $this->l('Add an addThis block');
  		$this->confirmUninstall = $this->l('Are you sure you want to delete your details ?');
	}
	public function install(){
		if (
			!parent::install() OR
			!$this->registerHook('top') OR
			!$this->registerHook('footer') OR
			!$this->registerHook('productfooter') OR
			!$this->registerHook('leftcolumn') OR
			!$this->registerHook('centercolumn') OR
			!$this->registerHook('rightcolumn') OR
			// Temporary hooks. Do NOT hook any module on it. Some CRUD hook will replace them as soon as possible.
			!$this->registerHook('categoryAddition') OR
			!$this->registerHook('categoryUpdate') OR
			!$this->registerHook('categoryDeletion') OR
			!$this->registerHook('afterSaveAdminMeta') OR
			!Configuration::updateValue('BLOCK_ADDTHIS_HOOK_TOP', 0) OR 
			!Configuration::updateValue('BLOCK_ADDTHIS_HOOK_FOOTER', 0) OR 
			!Configuration::updateValue('BLOCK_ADDTHIS_HOOK_PRODUCTFOOTER', 0) OR 
			!Configuration::updateValue('BLOCK_ADDTHIS_HOOK_LEFTCOLUMN', 0) OR 
			!Configuration::updateValue('BLOCK_ADDTHIS_HOOK_CENTERCOLUMN', 0) OR 
			!Configuration::updateValue('BLOCK_ADDTHIS_HOOK_RIGHTCOLUMN', 0)
		){
			return false;
		}
		return true;
	}
	public function uninstall(){
		if (
			!parent::uninstall() OR
			!Configuration::deleteByName('BLOCK_ADDTHIS_HOOK_TOP') OR
			!Configuration::deleteByName('BLOCK_ADDTHIS_HOOK_FOOTER') OR
			!Configuration::deleteByName('BLOCK_ADDTHIS_HOOK_PRODUCTFOOTER') OR
			!Configuration::deleteByName('BLOCK_ADDTHIS_HOOK_LEFTCOLUMN') OR
			!Configuration::deleteByName('BLOCK_ADDTHIS_HOOK_CENTERCOLUMN') OR
			!Configuration::deleteByName('BLOCK_ADDTHIS_HOOK_RIGHTCOLUMN')
		){
			return false;
		}
		return true;
	}
	
	public function getContent(){
		$output = '<h2>'.$this->displayName.'</h2>';
		if (Tools::isSubmit('submitBlockAddThis')){
			// recup infos formulaire
			$formStyleChooseHookTop				= Tools::getValue('formStyleChooseHookTop');
			$formStyleChooseHookFooter			= Tools::getValue('formStyleChooseHookFooter');
			$formStyleChooseHookProductFooter	= Tools::getValue('formStyleChooseHookProductFooter');
			$formStyleChooseHookLeftColumn		= Tools::getValue('formStyleChooseHookLeftColumn');
			$formStyleChooseHookCenterColumn	= Tools::getValue('formStyleChooseHookCenterColumn');
			$formStyleChooseHookRightColumn		= Tools::getValue('formStyleChooseHookRightColumn');
				
			// verif
			if(
				$formStyleChooseHookTop < 0				||
				$formStyleChooseHookFooter < 0			||
				$formStyleChooseHookProductFooter < 0	||
				$formStyleChooseHookLeftColumn < 0		||
				$formStyleChooseHookCenterColumn < 0	||
				$formStyleChooseHookRightColumn < 0
			){
				//$output .= '<div class="alert error">'.$this->l('Maximum depth: Invalid number.').'</div>';
				$output .= $this->displayError($this->l('Style not positive'));
				
			}else{
				Configuration::updateValue('BLOCK_ADDTHIS_HOOK_TOP', (int)($formStyleChooseHookTop));
				Configuration::updateValue('BLOCK_ADDTHIS_HOOK_FOOTER', (int)($formStyleChooseHookFooter));
				Configuration::updateValue('BLOCK_ADDTHIS_HOOK_PRODUCTFOOTER', (int)($formStyleChooseHookProductFooter));
				Configuration::updateValue('BLOCK_ADDTHIS_HOOK_LEFTCOLUMN', (int)($formStyleChooseHookLeftColumn));
				Configuration::updateValue('BLOCK_ADDTHIS_HOOK_CENTERCOLUMN', (int)($formStyleChooseHookCenterColumn));
				Configuration::updateValue('BLOCK_ADDTHIS_HOOK_RIGHTCOLUMN', (int)($formStyleChooseHookRightColumn));
				
				$this->_clearAddthisCache();
				
				$output .= $this->displayConfirmation($this->l('Settings updated...'));
			}
		}
		return $output.$this->displayForm();
	}
	
	/**
	 * 
	 * Formulaire
	 */
	public function displayForm(){
		$liste = '
		<fieldset>
			<legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Settings').'</legend>
			Style 1 <img src="'.$this->_path.'images/style1.png" alt="style 1" title="style 1" /><br />
			Style 2 <img src="'.$this->_path.'images/style2.png" alt="style 2" title="style 2" /><br />
			Style 3 <img src="'.$this->_path.'images/style3.png" alt="style 3" title="style 3" /><br />
			Style 4 <img src="'.$this->_path.'images/style4.png" alt="style 4" title="style 4" /><br />
			Style 5 <img src="'.$this->_path.'images/style5.png" alt="style 5" title="style 5" /><br />
			Style 6 <img src="'.$this->_path.'images/style6.png" alt="style 6" title="style 6" /><br />
			Style 7 <img src="'.$this->_path.'images/style7.png" alt="style 7" title="style 7" /><br />
			Style 8 Follow Us<br />
			Style 9 Facebook (like) & Twitter (tweet)
		</fieldset>';
		
		$form = '
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
			<fieldset>
				<legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Settings').'</legend>
				
				<label>'.$this->l('Style choose for zone top').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookTop">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('BLOCK_ADDTHIS_HOOK_TOP') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				<label>'.$this->l('Style choose for zone footer').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookFooter">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('BLOCK_ADDTHIS_HOOK_FOOTER') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				<label>'.$this->l('Style choose for zone product footer').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookProductFooter">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('BLOCK_ADDTHIS_HOOK_PRODUCTFOOTER') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				
				
				
				<label>'.$this->l('Style choose for zone left column').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookLeftColumn">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('BLOCK_ADDTHIS_HOOK_LEFTCOLUMN') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				<label>'.$this->l('Style choose for zone center column').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookCenterColumn">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('BLOCK_ADDTHIS_HOOK_CENTERCOLUMN') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				<label>'.$this->l('Style choose for zone right column').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookRightColumn">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('BLOCK_ADDTHIS_HOOK_RIGHTCOLUMN') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				<center><input type="submit" name="submitBlockAddThis" value="'.$this->l('Save').'" class="button" /></center>
			</fieldset>
		</form>';
		
		return $liste.$form;
	}
	
	/*
	 * rightColumn
	 * home
	 * centerColumn
	 * productfooter
	 * extraRight
	 * leftColumn
	 * top
	 * footer
	 * productActions
	 * extraLeft
	 */
	
	/**
	*
	* retourne le style addthis a afficher
	* @param int $style
	*/
	public function getTypeAddthis( $style ){
		switch ($style){
			// HORIZONTAL
			case 1 :
				$s = '
					<div class="addthis_toolbox addthis_default_style ">
					<a class="addthis_button_facebook_like" fb:like:layout="button_count"></a>
					<a class="addthis_button_tweet"></a>
					<a class="addthis_button_pinterest_pinit"></a>
					<a class="addthis_counter addthis_pill_style"></a>
					</div>
					';
				break;
	
				// HORIZONTAL
			case 2 :
				$s = '
					<div class="addthis_toolbox addthis_default_style addthis_32x32_style">
					<a class="addthis_button_preferred_1"></a>
					<a class="addthis_button_preferred_2"></a>
					<a class="addthis_button_preferred_3"></a>
					<a class="addthis_button_preferred_4"></a>
					<a class="addthis_button_compact"></a>
					<a class="addthis_counter addthis_bubble_style"></a>
					</div>
					';
				break;
	
				// HORIZONTAL
			case 3 :
				$s ='
					<div class="addthis_toolbox addthis_default_style ">
					<a class="addthis_button_preferred_1"></a>
					<a class="addthis_button_preferred_2"></a>
					<a class="addthis_button_preferred_3"></a>
					<a class="addthis_button_preferred_4"></a>
					<a class="addthis_button_compact"></a>
					<a class="addthis_counter addthis_bubble_style"></a>
					</div>
					';
				break;
	
				// VERTICAL
			case 4 :
				$s ='
					<div class="addthis_toolbox addthis_floating_style addthis_counter_style" style="left:50px;top:50px;">
					<a class="addthis_button_facebook_like" fb:like:layout="box_count"></a>
					<a class="addthis_button_tweet" tw:count="vertical"></a>
					<a class="addthis_button_google_plusone" g:plusone:size="tall"></a>
					<a class="addthis_counter"></a>
					</div>
					';
				break;
	
				// VERTICAL
			case 5 :
				$s ='
					<div class="addthis_toolbox addthis_floating_style addthis_32x32_style" style="left:50px;top:50px;">
					<a class="addthis_button_preferred_1"></a>
					<a class="addthis_button_preferred_2"></a>
					<a class="addthis_button_preferred_3"></a>
					<a class="addthis_button_preferred_4"></a>
					<a class="addthis_button_compact"></a>
					</div>
					';
				break;
	
				// VERTICAL
			case 6 :
				$s ='
					<div class="addthis_toolbox addthis_floating_style addthis_16x16_style" style="left:50px;top:50px;">
					<a class="addthis_button_preferred_1"></a>
					<a class="addthis_button_preferred_2"></a>
					<a class="addthis_button_preferred_3"></a>
					<a class="addthis_button_preferred_4"></a>
					<a class="addthis_button_compact"></a>
					</div>
					';
				break;
	
				// HORIZONTAL
			case 7 :
				$s ='
					<a class="addthis_button" href="http://www.addthis.com/bookmark.php?v=250&amp;pubid=ra-5016ee8635214d7d"><img src="http://s7.addthis.com/static/btn/v2/lg-share-en.gif" width="125" height="16" alt="Bookmark and Share" style="border:0"/></a>
					';
				break;
	
			// HORIZONTAL
			case 8 :
				// remplacer xxx par votre username pour chaque compte
				$s = '
				<p>Suivez-nous</p>
				<div class="addthis_toolbox addthis_32x32_style addthis_default_style">
				<a class="addthis_button_facebook_follow" addthis:userid="xxx"></a>
				<a class="addthis_button_twitter_follow" addthis:userid="xxx"></a>
				<a class="addthis_button_linkedin_follow" addthis:userid="xxx"></a>
				<a class="addthis_button_google_follow" addthis:userid="xxx"></a>
				<a class="addthis_button_youtube_follow" addthis:userid="xxx"></a>
				<a class="addthis_button_flickr_follow" addthis:userid="xxx"></a>
				<a class="addthis_button_vimeo_follow" addthis:userid="xxx"></a>
				<a class="addthis_button_pinterest_follow" addthis:userid="xxx"></a>
				<a class="addthis_button_foursquare_follow" addthis:userid="xxx"></a>
				<a class="addthis_button_tumblr_follow" addthis:userid="xxx"></a>
				<a class="addthis_button_rss_follow" addthis:url="http://xxx"></a>
				</div>
				';
				break;
			
			// HORIZONTAL : fb like + tw tweet
			case 9 :
				$s = '
				<a class="addthis_button_facebook_like"></a>
				<a class="addthis_button_tweet"></a>
				';
				break;
				
				// HORIZONTAL
			default :
				$s ='
					<a class="addthis_button" href="http://www.addthis.com/bookmark.php?v=250&amp;pubid=ra-5016ee8635214d7d"><img src="http://s7.addthis.com/static/btn/v2/lg-share-en.gif" width="125" height="16" alt="Bookmark and Share" style="border:0"/></a>
					';
	
		}
		return "<!-- AddThis Button BEGIN -->".$s."<!-- AddThis Button END -->";
	}
	
	/**
	 * 
	 * hook top
	 * @param array $params
	 */
	public function hookTop($params){
		global $smarty, $cookie;
		//echo "Cookie: ".$cookie->__get('typesite');
		
		$id_customer = (int)($params['cookie']->id_customer);
		// Get all groups for this customer and concatenate them as a string: "1,2,3..."
		// It is necessary to keep the group query separate from the main select query because it is used for the cache
		$groups = $id_customer ? implode(', ', Customer::getGroupsStatic($id_customer)) : _PS_DEFAULT_CUSTOMER_GROUP_;
		$id_product = (int)(Tools::getValue('id_product', 0));
		$id_category = (int)(Tools::getValue('id_category', 0));
		$id_lang = (int)($params['cookie']->id_lang);
		$smartyCacheId = 'addthis|'.$groups.'_'.$id_lang.'_'.$id_product.'_'.$id_category;
		Tools::enableCache();
		if (!$this->isCached('addthis-top.tpl', $smartyCacheId)){
			// traitement ici
			//if (Tools::isSubmit('submitBlockAddThis')){}
		}
		$smarty->cache_lifetime = 31536000; // 1 Year

		$style = $this->getTypeAddthis( Configuration::get('BLOCK_ADDTHIS_HOOK_TOP') );
		$smarty->assign('block_addthis_hook_top', $style);
		$display = $this->display(__FILE__, 'addthis-top.tpl', $smartyCacheId);
		Tools::restoreCacheSettings();
		return $display;
	}
	
	/**
	 * 
	 * hook footer
	 * @param array $params
	 */
	public function hookFooter($params){
		global $smarty, $cookie;
		
		$style = $this->getTypeAddthis( Configuration::get('BLOCK_ADDTHIS_HOOK_FOOTER') );
		$smarty->assign('block_addthis_hook_footer', $style);
		$display = $this->display(__FILE__, 'addthis-footer.tpl');
		return $display;
	}
	
	/**
	 * 
	 * hook product footer
	 * @param array $params
	 */
	public function hookProductFooter($params){
		global $smarty, $cookie;

		$style = $this->getTypeAddthis( Configuration::get('BLOCK_ADDTHIS_HOOK_PRODUCTFOOTER') );
		$smarty->assign('block_addthis_hook_productfooter', $style);
		$display = $this->display(__FILE__, 'addthis-productfooter.tpl');
		return $display;
	}

	
	/**
	 *
	 * hook left column
	 * @param array $params
	 */
	public function hookLeftColumn($params){
		global $smarty, $cookie;
		
		$style = $this->getTypeAddthis( Configuration::get('BLOCK_ADDTHIS_HOOK_LEFTCOLUMN') );
		$smarty->assign('block_addthis_hook_leftcolumn', $style);
		$display = $this->display(__FILE__, 'addthis-leftcolumn.tpl');
		return $display;
	}
	
	/**
	 *
	 * hook center column
	 * @param array $params
	 */
	public function hookCenterColumn($params){
		global $smarty, $cookie;
		
		$style = $this->getTypeAddthis( Configuration::get('BLOCK_ADDTHIS_HOOK_CENTERCOLUMN') );
		$smarty->assign('block_addthis_hook_centercolumn', $style);
		$display = $this->display(__FILE__, 'addthis-centercolumn.tpl');
		return $display;
	}
	
	/**
	*
	* hook right column
	* @param array $params
	*/
	public function hookRightColumn($params){
		global $smarty, $cookie;
	
		$style = $this->getTypeAddthis( Configuration::get('BLOCK_ADDTHIS_HOOK_RIGHTCOLUMN') );
		$smarty->assign('block_addthis_hook_rightcolumn', $style);
		$display = $this->display(__FILE__, 'addthis-rightcolumn.tpl');
		return $display;
	}
	
	/**
	 * 
	 * vider le cache
	 */
	private function _clearAddthisCache(){
		$this->_clearCache('addthis.tpl');
		Tools::restoreCacheSettings();
	}
	public function hookCategoryAddition($params){
		$this->_clearAddthisCache();
	}
	public function hookCategoryUpdate($params){
		$this->_clearAddthisCache();
	}
	public function hookCategoryDeletion($params){
		$this->_clearAddthisCache();
	}
	public function hookAfterSaveAdminMeta($params){
		$this->_clearAddthisCache();
	}
}